#include <windows.h>
#include <stdio.h>
#include "resource.h"

#define REGNAME_ROOT "SYSTEM\\CurrentControlSet\\Services\\POSServ\\Parameters"
/* type: REG_SZ */
#define REGNAME_USERNAME    "username"
#define REGNAME_HOSTNAME    "hostname"
#define REGNAME_KEYPATH     "keypath"
#define REGNAME_SESSIONNAME "session"
#define REGNAME_CMDLINE     "commandline"
/* type: REG_DWORD */
#define REGNAME_SSHPROTOCOL "protocol"
#define REGNAME_PORTNUMBER  "port" /* 0 indicates 'use default port' */
#define REGNAME_USESESSION  "usesession"
#define REGNAME_USECMDLINE  "usecommandline"

/* below values includes NULL terminator */
#define PROFNAME_MAX    (32 + 1) 
#define HOSTNAME_MAX    (1024)
#define USERNAME_MAX    (1024)
#define KEYPATH_MAX     (MAX_PATH)
#define SESSIONNAME_MAX (1024)
#define CMDLINE_MAX     (4096)

extern HINSTANCE hInstance;

/* for DLL export */
#ifdef BUILD_EXPORTABLE
#define EXPORTABLE __declspec(dllexport)
#else
#define EXPORTABLE
#endif

typedef struct profiledata_tag {
	CHAR hostname[HOSTNAME_MAX];
	CHAR username[USERNAME_MAX];
	CHAR keypath[KEYPATH_MAX];
	DWORD ssh_proto;
	BOOL use_session;
	CHAR session[SESSIONNAME_MAX];
	USHORT port;
	BOOL use_cmdline;
	CHAR cmdline[CMDLINE_MAX];
} profiledata;

#ifdef __cplusplus
extern "C" {
#endif

/* profrw.c */
BOOL DeleteProfile(const char *profile);
BOOL SaveProfile(const char *profile, const profiledata *profdata);
BOOL IsProfileExists(const char *profile);
BOOL LoadProfile(const char *profile, profiledata *profdata);
int BuildOptions(char *optbuf, int maxlen, const profiledata *profdata);

/* editconf.c */
BOOL EditProfile(const char *target);

/* vpnconf.c */
BOOL Configure(void);

#ifdef __cplusplus
}
#endif
