#include "common.h"

/* "[AȂƂȂ˂ */
static const char *g_ConfigureTarget = NULL;

static void OnToggleCheckBox_Expart(HWND hWnd);
static BOOL GetProfileData(HWND hWnd, profiledata *profdata, int disp_error);

/* ------------------------------------------------------------------------ */

static BOOL UpdateProfileData(HWND hWnd)
{
	profiledata profdata;

	/* set default settings */
	SendDlgItemMessage(hWnd, IDC_PROFNAME, WM_SETTEXT, 0, (LPARAM)"");
	SendDlgItemMessage(hWnd, IDC_USERNAME, WM_SETTEXT, 0, (LPARAM)"");
	SendDlgItemMessage(hWnd, IDC_HOSTNAME, WM_SETTEXT, 0, (LPARAM)"");
	SendDlgItemMessage(hWnd, IDC_KEYPATH, WM_SETTEXT, 0, (LPARAM)"");
	SendDlgItemMessage(hWnd, IDC_SSH1, BM_SETCHECK, BST_UNCHECKED, 0);
	SendDlgItemMessage(hWnd, IDC_SSH2, BM_SETCHECK, BST_CHECKED, 0);
	SendDlgItemMessage(hWnd, IDC_CHPORTNUM, BM_SETCHECK, BST_UNCHECKED, 0);
	SendDlgItemMessage(hWnd, IDC_PORTNUM, WM_SETTEXT, 0, (LPARAM)"");
	SendDlgItemMessage(hWnd, IDC_USESESSION, BM_SETCHECK, BST_UNCHECKED, 0);
	SendDlgItemMessage(hWnd, IDC_SESSION, WM_SETTEXT, 0, (LPARAM)"");
	SendDlgItemMessage(hWnd, IDC_EXPART, BM_SETCHECK, BST_UNCHECKED, 0);
	/* TODO: make command line */
	OnToggleCheckBox_Expart(hWnd);

	if(!g_ConfigureTarget) {
		/* New profile, leave as default */
		return TRUE;
	}
	if(!LoadProfile(g_ConfigureTarget, &profdata))
		return FALSE; /* ށ[A܂[hł񂩂 */

	if(profdata.use_cmdline) {
		SendDlgItemMessage(hWnd, IDC_PROFNAME, WM_SETTEXT, 0, (LPARAM)g_ConfigureTarget);
		SendDlgItemMessage(hWnd, IDC_EXPART, BM_SETCHECK, BST_CHECKED, 0);
		SendDlgItemMessage(hWnd, IDC_CMDLINE, WM_SETTEXT, 0, (LPARAM)profdata.cmdline);
	} else {
		SendDlgItemMessage(hWnd, IDC_PROFNAME, WM_SETTEXT, 0, (LPARAM)g_ConfigureTarget);
		SendDlgItemMessage(hWnd, IDC_USERNAME, WM_SETTEXT, 0, (LPARAM)profdata.username);
		SendDlgItemMessage(hWnd, IDC_HOSTNAME, WM_SETTEXT, 0, (LPARAM)profdata.hostname);
		SendDlgItemMessage(hWnd, IDC_KEYPATH, WM_SETTEXT, 0, (LPARAM)profdata.keypath);
		if(profdata.ssh_proto == 2) {
			SendDlgItemMessage(hWnd, IDC_SSH1, BM_SETCHECK, BST_UNCHECKED, 0);
			SendDlgItemMessage(hWnd, IDC_SSH2, BM_SETCHECK, BST_CHECKED, 0);
		} else {
			SendDlgItemMessage(hWnd, IDC_SSH1, BM_SETCHECK, BST_CHECKED, 0);
			SendDlgItemMessage(hWnd, IDC_SSH2, BM_SETCHECK, BST_UNCHECKED, 0);
		}
		if(profdata.port != 0) {
			char prebuf[16];
			sprintf(prebuf, "%u", profdata.port);
			SendDlgItemMessage(hWnd, IDC_CHPORTNUM, BM_SETCHECK, BST_CHECKED, 0);
			SendDlgItemMessage(hWnd, IDC_PORTNUM, WM_SETTEXT, 0, (LPARAM)prebuf);
		}
		if(profdata.use_session) {
			SendDlgItemMessage(hWnd, IDC_USESESSION, BM_SETCHECK, BST_CHECKED, 0);
			SendDlgItemMessage(hWnd, IDC_SESSION, WM_SETTEXT, 0, (LPARAM)profdata.session);
		}
	}
	OnToggleCheckBox_Expart(hWnd);
	return TRUE;
}

/* ------------------------------------------------------------------------ */

static void OnToggleCheckBox_PortNum(HWND hWnd)
{
	int bSet = (SendDlgItemMessage(hWnd, IDC_CHPORTNUM, 
									BM_GETCHECK, 0, 0) == BST_CHECKED);
	EnableWindow(GetDlgItem(hWnd, IDC_S_PORTNUM), bSet);
	EnableWindow(GetDlgItem(hWnd, IDC_PORTNUM), bSet);
}

/* ------------------------------------------------------------------------ */

static void OnToggleCheckBox_Session(HWND hWnd)
{
	int bSet = (SendDlgItemMessage(hWnd, IDC_USESESSION, 
									BM_GETCHECK, 0, 0) == BST_CHECKED);
	EnableWindow(GetDlgItem(hWnd, IDC_S_SESSION), bSet);
	EnableWindow(GetDlgItem(hWnd, IDC_SESSION), bSet);
}

/* ------------------------------------------------------------------------ */

static void OnToggleCheckBox_Expart(HWND hWnd)
{
	int bSet = (SendDlgItemMessage(hWnd, IDC_EXPART, 
									BM_GETCHECK, 0, 0) == BST_CHECKED);
	EnableWindow(GetDlgItem(hWnd, IDC_S_HOSTNAME), !bSet);
	EnableWindow(GetDlgItem(hWnd, IDC_HOSTNAME), !bSet);
	EnableWindow(GetDlgItem(hWnd, IDC_S_USERNAME), !bSet);
	EnableWindow(GetDlgItem(hWnd, IDC_USERNAME), !bSet);
	EnableWindow(GetDlgItem(hWnd, IDC_S_KEYPATH), !bSet);
	EnableWindow(GetDlgItem(hWnd, IDC_KEYPATH), !bSet);
	EnableWindow(GetDlgItem(hWnd, IDC_BROWSE), !bSet);
	EnableWindow(GetDlgItem(hWnd, IDC_S_PROTO), !bSet);
	EnableWindow(GetDlgItem(hWnd, IDC_SSH1), !bSet);
	EnableWindow(GetDlgItem(hWnd, IDC_SSH2), !bSet);
	if(bSet) {
		EnableWindow(GetDlgItem(hWnd, IDC_CHPORTNUM), !bSet);
		EnableWindow(GetDlgItem(hWnd, IDC_S_PORTNUM), !bSet);
		EnableWindow(GetDlgItem(hWnd, IDC_PORTNUM), !bSet);
		EnableWindow(GetDlgItem(hWnd, IDC_USESESSION), !bSet);
		EnableWindow(GetDlgItem(hWnd, IDC_S_SESSION), !bSet);
		EnableWindow(GetDlgItem(hWnd, IDC_SESSION), !bSet);
	} else {
		EnableWindow(GetDlgItem(hWnd, IDC_CHPORTNUM), !bSet);
		EnableWindow(GetDlgItem(hWnd, IDC_USESESSION), !bSet);
		OnToggleCheckBox_PortNum(hWnd);
		OnToggleCheckBox_Session(hWnd);
	}
	EnableWindow(GetDlgItem(hWnd, IDC_CMDLINE), bSet);
}

/* ------------------------------------------------------------------------ */

static void BuildCommandLineFromOptions(HWND hWnd)
{
	profiledata profdata;
	char buffer[CMDLINE_MAX];
	if(!GetProfileData(hWnd, &profdata, 0))
		return;
	if(profdata.use_cmdline)
		return;
	BuildOptions(buffer, CMDLINE_MAX, &profdata);
	SendDlgItemMessage(hWnd, IDC_CMDLINE, WM_SETTEXT, 0, (LPARAM)buffer);
}

/* ------------------------------------------------------------------------ */

#define SETTEXT(ctlid, setto, errormsg, is_error)								\
	do {																	\
		if(SendDlgItemMessage(hWnd, ctlid,										\
							  WM_GETTEXTLENGTH, 0, 0) >= sizeof(setto)) {		\
			if(is_error) {														\
				char msgbuf[512];													\
				sprintf(msgbuf, "%s is too long.\nYou can use up to %d characters.",  \
						errormsg, sizeof(setto) - 1);								\
				MessageBox(hWnd, msgbuf, "Edit profile", MB_OK);				  \
				SetFocus(GetDlgItem(hWnd, ctlid));									\
				return FALSE;														\
			}																		\
		}																		\
		SendDlgItemMessage(hWnd, ctlid, WM_GETTEXT, sizeof(setto), (LPARAM)setto); \
		if(setto[0] == '\0' && is_error) {											\
			if(is_error) {														\
				char msgbuf[512];													\
				sprintf(msgbuf, "Fill %s.",										\
						errormsg);													\
				MessageBox(hWnd, msgbuf, "Edit profile", MB_OK);				\
				SetFocus(GetDlgItem(hWnd, ctlid));									\
			}																	\
			return FALSE;														\
		}																		\
	} while(0)

static BOOL GetProfileData(HWND hWnd, profiledata *profdata, int disp_error)
{
	if(SendDlgItemMessage(hWnd, IDC_EXPART, BM_GETCHECK, 0, 0) == BST_CHECKED) {
		profdata->use_cmdline = 1;
		SETTEXT(IDC_CMDLINE, profdata->cmdline, "Commandline", disp_error);
	} else {
		profdata->use_cmdline = 0;
		SETTEXT(IDC_HOSTNAME, profdata->hostname, "Host", disp_error);
		SETTEXT(IDC_USERNAME, profdata->username, "User name", disp_error);
		SETTEXT(IDC_KEYPATH,  profdata->keypath,  "Identity file", disp_error);
		profdata->ssh_proto = 
			(SendDlgItemMessage(hWnd, IDC_SSH2, BM_GETCHECK, 0, 0) == BST_CHECKED)
			? 2 : 1;
		profdata->use_session = (SendDlgItemMessage(hWnd, IDC_USESESSION, 
												   BM_GETCHECK, 0, 0) == BST_CHECKED);
		if(profdata->use_session)
			SETTEXT(IDC_SESSION, profdata->session, "PuTTY Session file", disp_error);
		if(SendDlgItemMessage(hWnd, IDC_CHPORTNUM, 
							  BM_GETCHECK, 0, 0) == BST_CHECKED) {
			char portnumbuf[512];
			int pnum;
			SETTEXT(IDC_PORTNUM, portnumbuf, "Port number", disp_error);
			pnum = atoi(portnumbuf);
			if(pnum < 1 || pnum > 65535) {
				if(disp_error) {
					MessageBox(hWnd, "A port number must be between 1 and 65535.", 
							   "Edit profile", MB_OK);
					SetFocus(GetDlgItem(hWnd, IDC_PORTNUM));
				}
				return FALSE;
			}
			profdata->port = (USHORT)pnum;
		} else {
			profdata->port = 0;
		}
	}
	return TRUE;
}

/* ------------------------------------------------------------------------ */

static BOOL CommitProfile(HWND hWnd)
{
	char profile[PROFNAME_MAX];
	profiledata profdata;

	SETTEXT(IDC_PROFNAME, profile, "Name", 1);
	if(!GetProfileData(hWnd, &profdata, 1))
		return FALSE;
	if((!g_ConfigureTarget 
	 || (g_ConfigureTarget && _stricmp(profile, g_ConfigureTarget) != 0))
	&& IsProfileExists(profile)) {
		char msgbuf[512];
		sprintf(msgbuf, "A profile %s already exists.  Overwrite it?",
				profile);
		if(MessageBox(hWnd, msgbuf, "Edit profile", 
			MB_YESNO | MB_ICONQUESTION | MB_DEFBUTTON2) == IDNO) {
			SetFocus(GetDlgItem(hWnd, IDC_PROFNAME));
			return FALSE;
		}
	}
	if(g_ConfigureTarget != NULL) {
		if(_stricmp(profile, g_ConfigureTarget) != 0) {
			if(!DeleteProfile(g_ConfigureTarget)) {
				char msgbuf[512];
				sprintf(msgbuf, "Failed to delete the profile %s.",
						g_ConfigureTarget);
				MessageBox(hWnd, msgbuf, "Edit profile", MB_OK);
			}
		}
	}
	if(!SaveProfile(profile, &profdata)) {
		char msgbuf[512];
		sprintf(msgbuf, "Failed to save the profile %s.",
				profile);
		MessageBox(hWnd, msgbuf, "Edit profile", MB_OK);
		return FALSE;
	}
	return TRUE;
}

/* ------------------------------------------------------------------------ */

static void BrowseKeyFile(HWND hWnd)
{
	OPENFILENAME ofn;
	char filename[KEYPATH_MAX];

	*filename = '\0';
	if(SendDlgItemMessage(hWnd, IDC_KEYPATH, 
						  WM_GETTEXTLENGTH, 0, 0) < sizeof(filename)) {
		SendDlgItemMessage(hWnd, IDC_KEYPATH, WM_GETTEXT, 
						   sizeof(filename), (LPARAM)filename);
	}

	memset(&ofn, 0, sizeof(OPENFILENAME));
	ofn.lStructSize = sizeof(OPENFILENAME);
	ofn.hwndOwner = hWnd;
	ofn.lpstrFilter = "PuTTY secret keys (*.ppk)\0*.ppk\0All files\0*.*\0";
	ofn.lpstrTitle = "Identity file";
	ofn.lpstrFile = filename;
	ofn.nMaxFile = sizeof(filename);
	ofn.Flags = OFN_ENABLESIZING | OFN_FILEMUSTEXIST | OFN_HIDEREADONLY
			  | OFN_PATHMUSTEXIST;
	if(GetOpenFileName(&ofn)) {
		SendDlgItemMessage(hWnd, IDC_KEYPATH, WM_SETTEXT, 
						   0, (LPARAM)filename);
		SendDlgItemMessage(hWnd, IDC_KEYPATH, EM_SETSEL, 0, (LPARAM)-1);
	}

}

/* ------------------------------------------------------------------------ */

/* on coming WM_COMMAND on IDD_CONFDLG */
static BOOL OnConfDlgCommand(HWND hWnd, WORD wId, WORD wAction)
{
	switch(wId) {
	case IDC_USERNAME:
	case IDC_HOSTNAME:
	case IDC_KEYPATH:
	case IDC_PORTNUM:
	case IDC_SESSION:
		if(wAction == EN_CHANGE)
			BuildCommandLineFromOptions(hWnd);
		break;
	case IDC_SSH1:
	case IDC_SSH2:
		BuildCommandLineFromOptions(hWnd);
		break;
	case IDC_BROWSE:
		BrowseKeyFile(hWnd);
		BuildCommandLineFromOptions(hWnd);
		break;
	case IDC_CHPORTNUM:
		OnToggleCheckBox_PortNum(hWnd);
		BuildCommandLineFromOptions(hWnd);
		break;
	case IDC_USESESSION:
		OnToggleCheckBox_Session(hWnd);
		BuildCommandLineFromOptions(hWnd);
		break;
	case IDC_EXPART:
		OnToggleCheckBox_Expart(hWnd);
		BuildCommandLineFromOptions(hWnd);
		break;
	case IDOK:
		if(!CommitProfile(hWnd))
			break;
		/* falling down... */
	case IDCANCEL:
		EndDialog(hWnd, wId);
		return TRUE;
	}
	return FALSE;
}

/* ------------------------------------------------------------------------ */

static BOOL CALLBACK ConfDlgProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch(uMsg) {
	case WM_INITDIALOG:
		UpdateProfileData(hWnd);
		BuildCommandLineFromOptions(hWnd);
		return TRUE;
	case WM_COMMAND:
		return OnConfDlgCommand(hWnd, LOWORD(wParam), HIWORD(wParam));
	}
	return FALSE;
}

/* ------------------------------------------------------------------------ */

BOOL EditProfile(const char *target)
{
	g_ConfigureTarget = target;
	return DialogBox(hInstance, MAKEINTRESOURCE(IDD_CONFDLG), 
					 NULL, (DLGPROC)ConfDlgProc) == IDOK ? TRUE : FALSE;
}
